package com.something.layout;

import java.util.List;

import org.eclipse.wb.internal.core.model.clipboard.ClipboardCommand;
import org.eclipse.wb.internal.core.model.creation.CreationSupport;
import org.eclipse.wb.internal.core.model.description.ComponentDescription;
import org.eclipse.wb.internal.core.utils.ast.AstEditor;
import org.eclipse.wb.internal.swt.model.layout.GenericFlowLayoutInfo;
import org.eclipse.wb.internal.swt.model.layout.LayoutClipboardCommand;
import org.eclipse.wb.internal.swt.model.widgets.ControlInfo;
import org.eclipse.wb.internal.swt.support.FillLayoutSupport;

public class SomeLayoutInfo extends GenericFlowLayoutInfo {
	// //////////////////////////////////////////////////////////////////////////
	//
	// Constructor
	//
	// //////////////////////////////////////////////////////////////////////////
	public SomeLayoutInfo(AstEditor editor, ComponentDescription description, CreationSupport creationSupport) throws Exception {
		super(editor, description, creationSupport);
		System.out.println("Info constructor");
		new SomeLayoutAssistant(this);
	}

	// //////////////////////////////////////////////////////////////////////////
	//
	// Styles
	//
	// //////////////////////////////////////////////////////////////////////////
	public boolean isHorizontal() {
		return FillLayoutSupport.isHorizontal(getObject());
	}

	// //////////////////////////////////////////////////////////////////////////
	//
	// Clipboard
	//
	// //////////////////////////////////////////////////////////////////////////
	@Override
	protected void clipboardCopy_addControlCommands(ControlInfo control, List<ClipboardCommand> commands) throws Exception {
		commands.add(new LayoutClipboardCommand<SomeLayoutInfo>(control) {
			private static final long serialVersionUID = 0L;

			@Override
			protected void add(SomeLayoutInfo layout, ControlInfo control) throws Exception {
				layout.command_CREATE(control, null);
			}
		});
	}
}
